﻿Imports GoogleAnalytics
Imports System.Text
Imports System.Threading.Tasks

Namespace ERP.Client.Analytics
	Public Class PlatformInfoProvider
		Implements IPlatformInfoProvider
'INSTANT VB NOTE: The variable anonymousClientId was renamed since Visual Basic does not allow class members with the same name:
		Private anonymousClientId_Renamed As String
'INSTANT VB NOTE: The variable screenColors was renamed since Visual Basic does not allow class members with the same name:
		Private screenColors_Renamed? As Integer
'INSTANT VB NOTE: The variable screenResolution was renamed since Visual Basic does not allow class members with the same name:
		Private screenResolution_Renamed? As Dimensions
'INSTANT VB NOTE: The variable userAgent was renamed since Visual Basic does not allow class members with the same name:
		Private userAgent_Renamed As String
'INSTANT VB NOTE: The variable userLanguage was renamed since Visual Basic does not allow class members with the same name:
		Private userLanguage_Renamed As String
'INSTANT VB NOTE: The variable viewPortResolution was renamed since Visual Basic does not allow class members with the same name:
		Private viewPortResolution_Renamed? As Dimensions

		Public Sub New()
			InitializeWindow()
		End Sub

		Public Property AnonymousClientId() As String Implements IPlatformInfoProvider.AnonymousClientId
			Get
				Return Me.anonymousClientId_Renamed
			End Get
			Private Set(ByVal value As String)
				Me.anonymousClientId_Renamed = value
			End Set
		End Property

		Public Property ScreenColors() As Integer? Implements IPlatformInfoProvider.ScreenColors
			Get
				Return Me.screenColors_Renamed
			End Get
			Private Set(ByVal value? As Integer)
				Me.screenColors_Renamed = value
			End Set
		End Property

		Public Property ScreenResolution() As Dimensions? Implements IPlatformInfoProvider.ScreenResolution
			Get
				Return Me.screenResolution_Renamed
			End Get
			Private Set(ByVal value? As Dimensions)
				Me.screenResolution_Renamed = value
				RaiseEvent ScreenResolutionChanged(Me, EventArgs.Empty)
			End Set
		End Property

		Public Property UserAgent() As String Implements IPlatformInfoProvider.UserAgent
			Get
				Return Me.userAgent_Renamed
			End Get
			Private Set(ByVal value As String)
				Me.userAgent_Renamed = value
			End Set
		End Property

		Public Property UserLanguage() As String Implements IPlatformInfoProvider.UserLanguage
			Get
				Return Me.userLanguage_Renamed
			End Get
			Private Set(ByVal value As String)
				Me.userLanguage_Renamed = value
			End Set
		End Property

		Public Property ViewPortResolution() As Dimensions? Implements IPlatformInfoProvider.ViewPortResolution
			Get
				Return Me.viewPortResolution_Renamed
			End Get
			Private Set(ByVal value? As Dimensions)
				Me.viewPortResolution_Renamed = value
				RaiseEvent ViewPortResolutionChanged(Me, EventArgs.Empty)
			End Set
		End Property

		Public Event ScreenResolutionChanged As EventHandler Implements IPlatformInfoProvider.ScreenResolutionChanged
		Public Event ViewPortResolutionChanged As EventHandler Implements IPlatformInfoProvider.ViewPortResolutionChanged
		Public Sub OnTracking() Implements IPlatformInfoProvider.OnTracking
		End Sub

		Private Sub InitializeWindow()
			Me.AnonymousClientId = Guid.NewGuid().ToString()
			Me.ScreenResolution = Me.GetScreenResolution()
			Me.UserAgent = Me.GetUserAgent() '"Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; rv:11.0) like Gecko";
			Me.UserLanguage = Me.GetUserLanguage()
			Me.ViewPortResolution = Me.GetViewPortResolution()
		End Sub

		Private Function GetScreenResolution() As Dimensions?
			Return New Dimensions(Screen.PrimaryScreen.Bounds.Width, Screen.PrimaryScreen.Bounds.Height)
		End Function

		Private Function GetUserAgent() As String
			Return Environment.OSVersion.ToString()
		End Function

		Private Function GetUserLanguage() As String
			Return System.Globalization.CultureInfo.CurrentUICulture.Name
		End Function

		Private Function GetViewPortResolution() As Dimensions?
			Return New Dimensions(Screen.PrimaryScreen.Bounds.Width, Screen.PrimaryScreen.Bounds.Height)
		End Function
	End Class
End Namespace
