﻿Imports System.ComponentModel
Imports System.Text
Imports System.Threading.Tasks
Imports ERP.Repository.Service
Imports ERP.Repository
Imports Telerik.WinControls
Imports System.Data.Services.Client
Imports Telerik.WinControls.UI

Namespace ERP.Client
	Partial Public Class OrderDetailsControl
		Inherits UserControl
'INSTANT VB NOTE: The variable data was renamed since Visual Basic does not allow class members with the same name:
		Private data_Renamed As SalesOrderHeader
		Private shippingHelper As MapLocationHelper
		Private customerHelper As MapLocationHelper

		Private shipingAddressBackup As New Address()
		Private customerAddressBackup As New Address()
		Public Sub New()
			InitializeComponent()

			Me.orderDetailsPageView.SelectedPage = Me.shipingDetailsPage
			radGridView1.EnableFiltering = True
			radGridView1.ShowFilteringRow = False
			radGridView1.ShowHeaderCellButtons = True
			radGridView1.ReadOnly = True
			radGridView1.AutoSizeColumnsMode = Telerik.WinControls.UI.GridViewAutoSizeColumnsMode.Fill

			radGridView1.Columns(0).FieldName = "Product"
			radGridView1.Columns(1).FieldName = "CarrierTrackingNumber"
			radGridView1.Columns(2).FieldName = "OrderQty"
			radGridView1.Columns(3).FieldName = "UnitPrice"
			radGridView1.Columns(4).FieldName = "UnitPriceDiscount"
			radGridView1.Columns(5).FieldName = "LineTotal"
			radGridView1.Columns(6).FieldName = "ModifiedDate"

			AddHandler Me.orderDetailsPageView.SelectedPageChanged, AddressOf OrderDetailsPageView_SelectedPageChanged

			shippingHelper = New MapLocationHelper(shipingDetailsMapControl.MapControl)
			customerHelper = New MapLocationHelper(customerDetailsMapControl.MapControl)

			AddHandler Me.shipingDetailsMapControl.DataControl.CommandExecuted, AddressOf DataControl_CommandExecuted
			AddHandler Me.customerDetailsMapControl.DataControl.CommandExecuted, AddressOf DataControl_CommandExecuted
		End Sub

		Private Sub DataControl_CommandExecuted(ByVal sender As Object, ByVal e As DataDialogCommandEventArgs)
			If e.SavaChanges Then
				TryCast(Me.Data, ISavableObject).Save(False)
			Else
				TryCast(Me.Data, ISavableObject).Cancel()
				CloneAddress(data_Renamed.Address, Me.shipingAddressBackup)
				CloneAddress(data_Renamed.Customer.Address, Me.customerAddressBackup)
				UpdateData()
			End If


		End Sub

		Private Sub OrderDetailsPageView_SelectedPageChanged(ByVal sender As Object, ByVal e As EventArgs)
			If Me.data_Renamed Is Nothing Then
				RadMessageBox.Show("Please select entry in the above grid")
				Return
			End If
			If orderDetailsPageView.SelectedPage Is shipingDetailsPage Then
				If Me.data_Renamed.Address Is Nothing Then
					Return
				End If
				shippingHelper.UpdateMap(Me.data_Renamed.Address)
			ElseIf orderDetailsPageView.SelectedPage Is customerDetailsPage Then
				If Me.data_Renamed.Customer.Address Is Nothing Then
					Return
				End If
				customerHelper.UpdateMap(Me.data_Renamed.Customer.Address)
			End If
		End Sub

		Public Property Data() As SalesOrderHeader
			Get
				Return Me.data_Renamed
			End Get
			Set(ByVal value As SalesOrderHeader)
				data_Renamed = value
				CloneAddress(shipingAddressBackup, data_Renamed.Address)
				CloneAddress(customerAddressBackup, data_Renamed.Customer.Address)
				UpdateData()

			End Set
		End Property

		Private Sub UpdateData()


			'grid update
			Me.radGridView1.DataSource = data_Renamed.SalesOrderDetails

			'map update
			If Me.data_Renamed.Address IsNot Nothing Then
				shippingHelper.UpdateMap(Me.data_Renamed.Address)
			End If
			If Me.data_Renamed.Customer.Address IsNot Nothing Then
				customerHelper.UpdateMap(Me.data_Renamed.Customer.Address)
			End If


			'data layout update
			Me.shipingDetailsMapControl.DataControl.DataEntry.DataSource = data_Renamed.Address
			Me.customerDetailsMapControl.DataControl.DataEntry.DataSource = data_Renamed.Customer.Address

		End Sub
		Public Sub CloneAddress(ByVal adr1 As Address, ByVal adr2 As Address)

			adr1.AddressLine1 = adr2.AddressLine1
			adr1.AddressLine2 = adr2.AddressLine2
			adr1.City = adr2.City
			adr1.StateProvince = adr2.StateProvince
			adr1.PostalCode = adr2.PostalCode
			adr1.ModifiedDate = adr2.ModifiedDate


		End Sub

	End Class
End Namespace
