﻿Imports System.ComponentModel
Imports System.Text
Imports System.Threading.Tasks
Imports Telerik.WinControls
Imports Telerik.WinControls.Themes
Imports Telerik.WinControls.UI
Imports ERP.Client.Properties
Imports System.Reflection
Imports Telerik.WinControls.Analytics

Namespace ERP.Client
	Partial Public Class TopControl
		Inherits UserControl
		Private loadedThemes As New Dictionary(Of String, Boolean)()

		Public ReadOnly Property ViewLabel() As RadLabel
			Get
				Return Me.viewLabel_Renamed
			End Get
		End Property

		Public Sub New()
			InitializeComponent()

			Dim TempFluentTheme As FluentTheme = New FluentTheme()
			Dim TempVisualStudio2012DarkTheme As VisualStudio2012DarkTheme = New VisualStudio2012DarkTheme()

			InitializeThemesDropDown()
		End Sub
		Private Sub InitializeThemesDropDown()
            AddThemeItemToThemesDropDownList("Fluent", My.Resources.fluent)
            AddThemeItemToThemesDropDownList("Material", My.Resources.material)
            AddThemeItemToThemesDropDownList("MaterialPink", My.Resources.material_pink)
            AddThemeItemToThemesDropDownList("MaterialTeal", My.Resources.material_teal)
            AddThemeItemToThemesDropDownList("MaterialBlueGrey", My.Resources.material_blue_grey)
            AddThemeItemToThemesDropDownList("ControlDefault", My.Resources.control_default)
            AddThemeItemToThemesDropDownList("TelerikMetro", My.Resources.telerik_metro)
            AddThemeItemToThemesDropDownList("Windows8", My.Resources.windows8)

            loadedThemes.Add("ControlDefault", True)
			loadedThemes.Add("Fluent", True)

			chooseThemeDropDown.Text = "Fluent"
			ThemeResolutionService.ApplicationThemeName = "Fluent"
			AddHandler chooseThemeDropDown.SelectedIndexChanged, AddressOf ChooseThemeDropDown_SelectedIndexChanged
			chooseThemeDropDown.DropDownStyle = RadDropDownStyle.DropDownList


		End Sub

		Private Sub ChooseThemeDropDown_SelectedIndexChanged(ByVal sender As Object, ByVal e As Telerik.WinControls.UI.Data.PositionChangedEventArgs)
			Dim assemblyName = "Telerik.WinControls.Themes." & chooseThemeDropDown.SelectedItem.Text & ".dll"
			Dim themeName = chooseThemeDropDown.SelectedItem.Text
			Dim strTempAssmbPath = System.IO.Path.Combine(System.IO.Directory.GetCurrentDirectory(), assemblyName)
			If Not System.IO.File.Exists(strTempAssmbPath) Then ' we are in the case of QSF as exe, so the Path is different
				strTempAssmbPath = System.IO.Path.Combine(System.IO.Directory.GetCurrentDirectory(), "..\..\..\..\Bin40")
				strTempAssmbPath = System.IO.Path.Combine(strTempAssmbPath, assemblyName)

				If Not System.IO.File.Exists(strTempAssmbPath) Then
					strTempAssmbPath = System.IO.Path.Combine(System.IO.Directory.GetCurrentDirectory(), "..\..\..\..\bin\ReleaseTrial")
					strTempAssmbPath = System.IO.Path.Combine(strTempAssmbPath, assemblyName)
				End If
			End If

			If Not loadedThemes.ContainsKey(themeName) Then

				Dim themeAssembly As System.Reflection.Assembly = System.Reflection.Assembly.LoadFrom(strTempAssmbPath)
				Activator.CreateInstance(themeAssembly.GetType("Telerik.WinControls.Themes." & themeName & "Theme"))

				loadedThemes.Add(themeName, True)
			End If

			ThemeResolutionService.ApplicationThemeName = themeName
			If ControlTraceMonitor.AnalyticsMonitor IsNot Nothing Then
				ControlTraceMonitor.AnalyticsMonitor.TrackAtomicFeature("ThemeChanged." & themeName)
			End If
		End Sub

		Private Sub AddThemeItemToThemesDropDownList(ByVal themeName As String, ByVal image_Renamed As Image)
			Dim themeItem As New RadListDataItem()
			themeItem.Text = themeName
			themeItem.Image = image_Renamed
			Me.chooseThemeDropDown.Items.Add(themeItem)
		End Sub
	End Class
End Namespace
