﻿Imports System.Drawing.Drawing2D
Imports System.Text
Imports System.Threading.Tasks
Imports Telerik.WinControls
Imports Telerik.WinControls.Paint
Imports Telerik.WinControls.Primitives
Imports Telerik.WinControls.UI

Namespace ERP.Client
	Friend Class ColorCellElement
		Inherits VirtualGridCellElement
		Protected Overrides Sub UpdateInfo(ByVal args As VirtualGridCellValueNeededEventArgs)
			MyBase.UpdateInfo(args)
			Me.TextAlignment = ContentAlignment.MiddleLeft
			If Me.Value Is Nothing Then
				Me.Text = "No Color"
			End If
		End Sub

		Public Overrides Function IsCompatible(ByVal data As Integer, ByVal context As Object) As Boolean
			Dim rowElement As VirtualGridRowElement = TryCast(context, VirtualGridRowElement)

			Return data = 3 AndAlso rowElement.RowIndex >= 0
		End Function
		Protected Overrides ReadOnly Property ThemeEffectiveType() As Type
			Get
				Return GetType(VirtualGridCellElement)
			End Get
		End Property

		Protected Overrides Sub PostPaintElement(ByVal graphics As IGraphics)
			MyBase.PostPaintElement(graphics)
			Dim gr = (CType((CType(graphics, RadGdiGraphics)).Graphics, Graphics))

			gr.CompositingQuality = CompositingQuality.HighQuality
			gr.SmoothingMode = SmoothingMode.HighQuality

			If Me.Value IsNot Nothing Then
                Dim color = System.Drawing.Color.Transparent
                If Me.Value.ToString().StartsWith("#") Then
					color = ColorTranslator.FromHtml(Me.Value.ToString())
				ElseIf Not Me.Value.ToString().Contains("/"c) Then
					color = Color.FromName(Me.Value.ToString())
				End If

				Dim rect = New RectangleF(Size.Width - 20, 3, 18, Size.Height - 6)
				Using brush = New SolidBrush(color)
					gr.FillEllipse(brush,rect)
					gr.DrawEllipse(Pens.Black, rect)

				End Using
			End If

		End Sub

		Public Overrides ReadOnly Property CanEdit() As Boolean
			Get
				Return False
			End Get
		End Property
	End Class
End Namespace
