﻿Imports System.Text
Imports System.Threading.Tasks
Imports Telerik.WinControls
Imports Telerik.WinControls.UI

Namespace ERP.Client
	Friend Class RatingCellElement
		Inherits VirtualGridCellElement
		Private ratingElement As RadRatingElement

		Protected Overrides Sub CreateChildElements()
			MyBase.CreateChildElements()
			Me.ratingElement = New RadRatingElement()
			ratingElement.StretchHorizontally = True
			ratingElement.StretchVertically = True
			ratingElement.ShouldHandleMouseInput = False
			ratingElement.ReadOnly = True
			ratingElement.Minimum = 0
			ratingElement.Maximum = 5

			Me.ratingElement.CaptionElement.Visibility = ElementVisibility.Collapsed
			Me.ratingElement.DescriptionElement.Visibility = ElementVisibility.Collapsed
			Me.ratingElement.SubCaptionElement.Visibility = ElementVisibility.Collapsed

			For i As Integer = 0 To 4
				Dim star As New RatingStarVisualElement()
                star.MinSize = New System.Drawing.Size(10, 10)
                Me.ratingElement.Items.Add(star)
			Next i
			Me.ratingElement.IsInRadGridView = True
			Me.Children.Add(ratingElement)
		End Sub
		Protected Overrides Sub UpdateInfo(ByVal args As VirtualGridCellValueNeededEventArgs)
			MyBase.UpdateInfo(args)
			Me.Text = String.Empty
			If TypeOf args.Value Is Byte Then
				Me.ratingElement.Value = CByte(args.Value)
			End If
		End Sub
		Public Overrides Function IsCompatible(ByVal data As Integer, ByVal context As Object) As Boolean
			Dim rowElement As VirtualGridRowElement = TryCast(context, VirtualGridRowElement)

			Return data = 2 AndAlso rowElement.RowIndex >= 0
		End Function
		Protected Overrides ReadOnly Property ThemeEffectiveType() As Type
			Get
				Return GetType(VirtualGridCellElement)
			End Get
		End Property
		Protected Overrides Function ArrangeOverride(ByVal finalSize As SizeF) As SizeF
			Dim size As SizeF = MyBase.ArrangeOverride(finalSize)
            Me.ratingElement.Arrange(New RectangleF(New System.Drawing.Point(0, 0), size))
            Return size
		End Function
		Protected Overrides Sub DisposeManagedResources()
			MyBase.DisposeManagedResources()
			ratingElement = Nothing
		End Sub
		Public Overrides ReadOnly Property CanEdit() As Boolean
			Get
				Return False
			End Get
		End Property
	End Class
End Namespace
