﻿Imports ERP.Repository
Imports System.ComponentModel
Imports System.Data.Services.Client
Imports System.Linq.Expressions
Imports System.Text
Imports System.Threading.Tasks
Imports Telerik.WinControls.Data

Namespace ERP.Client
	Public NotInheritable Class SortHelper
		Private Sub New()
		End Sub
		Public Shared Function Sort(Of T As ISavableObject)(ByVal queryable As DataServiceQuery(Of T), ByVal sortDescriptors As SortDescriptorCollection) As DataServiceQuery(Of T)
			Dim query As DataServiceQuery(Of T) = queryable
			Dim isFirst As Boolean = True

			If sortDescriptors IsNot Nothing Then
				For Each descriptor In sortDescriptors
					Dim [property] = query.ElementType.GetProperty(descriptor.PropertyName)
					Dim parameter = Expression.Parameter(query.ElementType, "srt")
					Dim propertyAccess = Expression.MakeMemberAccess(parameter, [property])
                    Dim current_expression = Expression.Lambda(propertyAccess, parameter)

                    Dim methodName As String = String.Empty

					If isFirst Then
						methodName = If(descriptor.Direction = ListSortDirection.Ascending, "OrderBy", "OrderByDescending")
						isFirst = False
					Else
						methodName = If(descriptor.Direction = ListSortDirection.Ascending, "ThenBy", "ThenByDescending")
					End If
                    Dim exp = Expression.Call(GetType(Queryable), methodName, {query.ElementType, current_expression.Body.Type}, query.Expression, Expression.Quote(current_expression))

                    query = TryCast(query.Provider.CreateQuery(exp), DataServiceQuery(Of T))
				Next descriptor
			End If

			Return query
		End Function
	End Class
End Namespace
